;$Id: dcs_getcentroid.pro,v 1.2 2005/02/14 17:50:14 azuah Exp $
;###############################################################################
;
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;###############################################################################
pro dcs_getcentroid,summed_int,peakfrac,tstart,tstop,tcentroid,error
error=0
maxsummed_int=max(summed_int)
maxch=where(maxsummed_int eq summed_int,count)
if (count ne 1) then begin
	print,"More than one channel has peak intensity"
	error=1
	return
endif
channels=where(summed_int ge peakfrac*maxsummed_int,nchannels)
if (nchannels le 3) then begin
	print,"Too few channels in range determined by peakfrac."
	error=2
	return
endif
lchannel=channels[0]
rchannel=channels[nchannels-1]
tmean=(tstart+tstop)*0.5
twid=tstop-tstart
moment0=total(summed_int[lchannel:rchannel]*twid[lchannel:rchannel])
moment1=total(summed_int[lchannel:rchannel]*twid[lchannel:rchannel]*(tmean[lchannel:rchannel]-tmean[maxch[0]]))
tcentroid=moment1/moment0+tmean[maxch[0]]
end