; $Id: dcs_message_display.pro,v 1.4 2005/02/14 17:50:33 azuah Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
;###############################################################################
;
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;###############################################################################
pro dcs_message_display,lines,base,group_leader=group_leader,alignment=alignment
;************************************************************************************************
; This routine writes a message to the screen. It assumes there is already a top level base and it
; returns the ID of the message widget. Justification is determined by the keyword "alignment".
;
compile_opt strictarr
;
if (not keyword_set(alignment)) then alignment=0
;
nlines=n_elements(lines)
;
; Create the widget.
base=widget_base(title=' ',/col,group_leader=group_leader,/modal)
case alignment of
	-1: top=widget_label(base,value=lines[0],/align_left)
	 0: top=widget_label(base,value=lines[0],/align_center)
	 1: top=widget_label(base,value=lines[0],/align_right)
	else:
endcase
if (nlines gt 1) then begin
	mid=intarr(nlines)
	for i=1,nlines-1 do begin
		case alignment of
			-1: mid[i]=widget_label(base,value=lines[i],/align_left)
			 0: mid[i]=widget_label(base,value=lines[i],/align_center)
			 1: mid[i]=widget_label(base,value=lines[i],/align_right)
			else:
		endcase
	endfor
endif
bot=widget_base(title=' ',base,/row,/align_center)
;
; Realize the widget.
dave_position_tlb,base
widget_control,base,/realize
;
end
