; $Id: dm_center_kid.pro,v 1.6 2005/02/07 20:03:58 qiuym Exp $
;#######################################################################
;
; NAME:
;  dm_center_kid
;
; PURPOSE:
;  Center kid widget over parent widget.
;  If the parent is not specified, then the kid is centered over the screen
;
; CATEGORY:
;  general
;
; AUTHOR:
;  Yiming Qiu
;  NIST Center for Neutron Research
;  100 Bureau Drive, Gaithersburg, MD 20899-8562
;  United States
;  yiming.qiu@nist.gov
;  Feb, 2005
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;#######################################################################

; usage:
;   dm_center_kid,kid,parent
pro dm_center_kid,kid,parent,_extra=_extra
    if n_elements(kid) eq 0 then kid=0L
    if n_elements(parent) eq 0 then parent=0L
    if widget_info(kid,/valid_id) eq 0 then return
    if widget_info(parent,/valid_id) eq 0 then begin
       device,get_screen_size=center
       center=center/2.
    endif else begin
       geom=widget_info(parent,/geometry)
       center=[geom.xoffset+geom.scr_xsize/2.,geom.yoffset+geom.scr_ysize/2.]
    endelse
    geom=widget_info(kid,/geometry)
    widget_control,kid,xoffset=(0>(center[0]-geom.scr_xsize/2.)),yoffset=(0>(center[1]-geom.scr_ysize/2.)),_extra=_extra
end