; $Id: dm_mask_detbanks.pro,v 1.6 2005/02/07 20:03:58 qiuym Exp $
;#######################################################################
;
; NAME:
;  dm_mask_detbanks
;
; PURPOSE:
;  mask detector banks
;
; CATEGORY:
;  dcs_mslice
;
; AUTHOR:
;  Yiming Qiu
;  NIST Center for Neutron Research
;  100 Bureau Drive, Gaithersburg, MD 20899-8562
;  United States
;  yiming.qiu@nist.gov
;  Feb, 2005
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;#######################################################################

; parameter:
;   banks:    bank number to be masked -1:lower  0:central    1:upper
function dm_mask_detbanks,banks
    banknum=[$
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1,$
        1, 1, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0, 0, 0,-1,-1, 1, 1,$
        0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1,$
        1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1,$
        1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 0, 0, 1, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1, 0]
    for i=0,n_elements(banks)-1 do begin
       if abs(banks[i]) le 1 then begin
         if n_elements(mask) eq 0 then $
          mask = where(banknum eq banks[i]) $
         else $
          mask = [mask,where(banknum eq banks[i])]
       endif
    endfor
    if n_elements(mask) eq 0 then mask=-1
    mask = mask[sort(mask)]
    return,mask
end

