; $Id: dm_set_viewlabel.pro,v 1.7 2005/02/07 20:03:59 qiuym Exp $
;#######################################################################
;
; NAME:
;  dm_set_viewlabel
;
; PURPOSE:
;  construct view label
;
; CATEGORY:
;  dcs_mslice
;
; AUTHOR:
;  Yiming Qiu
;  NIST Center for Neutron Research
;  100 Bureau Drive, Gaithersburg, MD 20899-8562
;  United States
;  yiming.qiu@nist.gov
;  Feb, 2005
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;#######################################################################

; label : string
; viewaxis: four element array
function dm_set_viewlabel,label,viewaxis
    viewlabel='['
    if viewaxis[3] ne 0 then return, 'E (meV)'
    fixv=viewaxis  ;fixv    =  fix(viewaxis)
    viewlabel=viewlabel+(fixv[0] eq 0?'0':(abs(fixv[0]) eq 1?(fixv[0] eq 1?'':'-'):dm_to_string(fixv[0]))+label)+','
    viewlabel=viewlabel+(fixv[1] eq 0?'0':(abs(fixv[1]) eq 1?(fixv[1] eq 1?'':'-'):dm_to_string(fixv[1]))+label)+','
    viewlabel=viewlabel+(fixv[2] eq 0?'0':(abs(fixv[2]) eq 1?(fixv[2] eq 1?'':'-'):dm_to_string(fixv[2]))+label)+']'
    return,viewlabel
end