; $Id: dm_toggle_menubut.pro,v 1.5 2005/02/07 20:03:59 qiuym Exp $
;#######################################################################
;
; NAME:
;  dm_toggle_menubut
;
; PURPOSE:
;  this program check menu buttons according to IDL version
;  for v5.6 and later, a check will be applied(checked) or cancelled(unchecked)
;  for v5.5 and before,the button will be unsensitized(checked) or sensitized(unchecked)
;
; CATEGORY:
;  widget
;
; AUTHOR:
;  Yiming Qiu
;  NIST Center for Neutron Research
;  100 Bureau Drive, Gaithersburg, MD 20899-8562
;  United States
;  yiming.qiu@nist.gov
;  Feb, 2005
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;#######################################################################

; usage:
;   dm_toggle_menubut,check_but_id,uncheck_but_id
; parameters:
;   check_but_id:   the button id(s) to be checked
;   uncheck_but_id:   the button id(s) to be unchecked
pro dm_toggle_menubut,check_but_id,uncheck_but_id
    if float(!version.release) ge 5.6 then begin
       for i=0,n_elements(check_but_id)-1 do $
         widget_control,check_but_id[i],set_button=1
       for i=0,n_elements(uncheck_but_id)-1 do $
         widget_control,uncheck_but_id[i],set_button=0
    endif else begin
       for i=0,n_elements(check_but_id)-1 do $
         widget_control,check_but_id[i],sensitive=0
       for i=0,n_elements(uncheck_but_id)-1 do $
         widget_control,uncheck_but_id[i],sensitive=1
    endelse
end