; $Id: dm_widget_button.pro,v 1.2 2005/02/07 20:03:59 qiuym Exp $
;#######################################################################
;
; NAME:
;  dm_widget_button
;
; PURPOSE:
;  this program creates a widget_button,checked_menu keyword is set for IDL 5.6 or later
;
; CATEGORY:
;  widget
;
; AUTHOR:
;  Yiming Qiu
;  NIST Center for Neutron Research
;  100 Bureau Drive, Gaithersburg, MD 20899-8562
;  United States
;  yiming.qiu@nist.gov
;  Feb, 2005
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;#######################################################################

; parameter:
;   parent:     the widget ID of the parent for the new button widget
; keyword:
;   set_button:   initial check state of the button
;   onstring: button value when set_button=1 for IDL5.5 or before
;   offstring:    button value when set_button=0 for IDL5.5 or before
function dm_widget_button,parent,set_button=set_button,onstring=onstring,offstring=offstring,_extra=extra
    if float(!version.release) ge 5.6 then $
       id=widget_button(parent,_extra=extra,/checked_menu) $
    else $
       id=widget_button(parent,_extra=extra)
    if n_elements(set_button) eq 1 then dm_set_button,id,set_button,onstring=onstring,offstring=offstring
    return,id
end