; $Id: dcsreducerawdata.pro,v 1.16 2005/02/14 17:50:33 azuah Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
;###############################################################################
;
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;###############################################################################
pro DCSReduceRawData,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue=statePtr
davePtr=(*statePtr).davePtr
;
dcs_sysvars,davePtr=davePtr
;
tvlct,r,g,b,/get
rgbptr=ptr_new({r:r,g:g,b:b})
;
; Default root file name.
defsysv,'!dcs_default_root','dcs_test',0
;
; Assumed distance from sample to detectors.
defsysv,'!dcs_dsd',4010.0,1
;
;widget_control,/hourglass
;
dcs_defineDaveStructure,davePtr=davePtr
;
;inputfile=file_which("dcs_multiple_messages.txt",/include_current_dir)
inputfile=!DAVE_AUXILIARY_DIR+'dcs_multiple_messages.txt'
;
dcs_read_multiple_messages,inputfile,message_str
;
;device,/cursor_original
;
dcs_reduction,event.top,message_str,!screensize,davePtr=davePtr
;
dave_makeDavePtr,davePtr=davePtr
(*statePtr).davePtr=davePtr
;
tvlct,(*rgbptr).r,(*rgbptr).g,(*rgbptr).b
ptr_free,rgbptr
;
end
