; $Id: opan_rebin_focus_Energy_widget.pro,v 1.1 2005/09/12 12:06:15 tregenna Exp $
;###############################################################################
;
; NAME:
;  OPAN_REBIN_FOCUS_Energy_WIDGET
;
; PURPOSE:
;  This widget dialog allows the user to type in preferences for rebinning
;  the currently-loaded data set.
;
; CATEGORY:
;  DAVE, Data Analysis, PAN, curve fitting
;
;PD Dr. Philip Tregenna-Piggott,
;Laboratory for Neutron Scattering,
;ETHZ and Paul-Scherrer Institute,
;CH-5232 Villigen PSI,
;Switzerland.
;
;Tel. :+41 56 310 54 05
;Fax. :+41 56 310 29 39
;Email:philip.tregenna@psi.ch
;
;Based on the Program  opan_rebin_widget.pro by:
;   Robert M. Dimeo, Ph.D.
;   NIST Center for Neutron Research
;   100 Bureau Drive
;   Gaithersburg, MD 20899
;   Phone: (301) 975-8135
;   E-mail: robert.dimeo@nist.gov
;   http://www.ncnr.nist.gov/staff/dimeo
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
pro opan_focus_Energy_rw,event
widget_control,event.top,get_uvalue = pState
case event.id of
(*pState).cancelButton: $
         begin
           (*pState).out.cancel = 1
           widget_control,event.top,/destroy
           return
         end
(*pState).acceptButton: $
         begin
;      Try and avoid errors here from the user pressing accept button before
;      pressing return carriage
        widget_control,(*pState).ndesired_nb,get_value = nb_nbins
        (*pState).out.nb_nbins = fix(nb_nbins[0])
         widget_control,(*pState).xlo_nb,get_value = nb_xlo
         (*pState).out.nb_xlo = float(nb_xlo[0])
         widget_control,(*pState).xhi_nb,get_value = nb_xhi
         (*pState).out.nb_xhi = float(nb_xhi[0])
        widget_control,(*pState).ndesired_b,get_value = b_nbins
         (*pState).out.b_nbins = fix(b_nbins[0])
         widget_control,(*pState).xhi_b,get_value = b_xhi
         (*pState).out.b_xhi = float(b_xhi[0])
         widget_control,(*pState).xlo_b,get_value = b_xlo
         (*pState).out.b_xlo = float(b_xlo[0])
         widget_control,(*pState).step_size,get_value = step
         (*pState).out.step = float(step[0])
         widget_control,(*pState).ndesired_i,get_value = i_nbins
         (*pState).out.i_nbins = fix(i_nbins[0])
         widget_control,(*pState).xhi_i,get_value = i_xhi
         (*pState).out.i_xhi = float(i_xhi[0])
         widget_control,(*pState).xlo_i,get_value = i_xlo
         (*pState).out.i_xlo = float(i_xlo[0])

         widget_control,(*pState).units,get_value = unit
         (*pState).out.unit=fix(unit[0])

       ;
         (*pState).out.cancel = 0
;
         widget_control,event.top,/destroy
         return
       end
else:
endcase
uname=widget_info(event.id,/uname)
;print,'uname =',uname
case uname of
'Units':    $
begin
       widget_control,(*pState).units, get_value = unit
;       help,unit
;       help,fix(unit[0])
;       print,unit
       unit_arr=[(*pState).out.unit,fix(unit[0])]
       (*pState).out.unit=unit
;       help,unit_arr
;       print,unit_arr
;print,(*pState).unit_arr
if unit_arr[0] ne unit_arr[1] then begin
;print,unit_arr
unit_change_Energy,event,unit_arr=unit_arr
endif
end
'step_size':  $
    begin
;   here the step size is specified.  We have to update the other fields
    widget_control,(*pState).step_size,get_value = step
    widget_control,(*pState).xlo_b,get_value = b_xlo
    widget_control,(*pState).xhi_b,get_value = b_xhi
    step=double(step[0])
    b_xlo=double(b_xlo[0])
    b_xhi=double(b_xhi[0])
;
;    print,b_xhi
;
if step eq 0.0 then return
    b_nbins=(b_xhi-b_xlo)/step
;    print,b_nbins
    b_nbins=long(b_nbins)
;    print,b_nbins
 ;  prevent sum of bins in the two areas exceeding the total number of bins
     widget_control,(*pState).ndesired_nb,get_value = nb_nbins
      if (fix(nb_nbins[0])+fix(b_nbins[0])) gt (*pState).total_bins then begin
      b_nbins=(*pState).total_bins-nb_nbins
    widget_control,(*pState).ndesired_b,set_value=b_nbins
    ;   Re calculate step size
    step=(float(b_xhi[0])-float(b_xlo[0]))/(fix(b_nbins[0])-1)
     widget_control,(*pState).step_size,set_value = step
     return
    endif
     b_xhi=b_xlo+b_nbins*step
;    print,b_xhi
    widget_control,(*pState).xhi_b,set_value = b_xhi
    widget_control,(*pState).ndesired_b,set_value = b_nbins+1
;   update fields in interpolated area
       ;   find interpolated range
    x=(*pState).x
    widget_control,(*pState).ndesired_nb,get_value = nb_nbins

    where_x_lt_b_xhi=where(x lt float(b_xhi[0])-step/100.0,count)
  ;  print, 'woof'
  ;  print,(fix(nb_nbins[0])+1)
  ;  print,n_elements(where_x_le_b_xhi)
  ;  print,'woof'
    ix=x[fix(nb_nbins[0])-1:count]
    ;ix=x[(fix(nb_nbins[0])+1):*]
    ix_plus=ix[1:*]
    ix_minus=ix[0:(n_elements(ix)-1)]
    ix_diff=ix_plus-ix_minus
    ;print,ix_diff
    u=1+bytarr(n_elements(ix_diff))
    ustep=step*u
    where_int=where(ix_diff gt ustep,count)
    ;print,'where_int =',where_int
    ;print,'where_int + 1 =',where_int+1
    if count ge 1 then begin
;   help,ix
    ix=[ix[0],ix[(where_int+1)]]
;   help,ix
    i_nbins=count+1
    i_xlo=b_xlo
    i_xhi=max(ix)
    endif else begin
    i_nbins=0
    i_xlo=b_xlo
    i_xhi=b_xlo
    endelse
    widget_control,(*pState).ndesired_i,set_value = i_nbins
    widget_control,(*pState).xlo_i,set_value = i_xlo
    widget_control,(*pState).xhi_i,set_value = i_xhi



    end
'first_bin_point':  $
    begin
;    print,'woof'
    widget_control,event.id,get_value=b_xlo
    widget_control,(*pState).xhi_b,get_value = b_xhi
;   prevent first bin point being set to a value greater than the last bin point
    if float(b_xlo[0]) ge float(b_xhi[0]) then begin
    x=(*pState).x
    where_lt=where(x lt float(b_xhi[0]),count)
;    print,count
    b_xlo=x[where_lt[count-2]]
        widget_control,event.id,set_value=b_xlo
;    print,b_xlo
    endif
;    print,b_xlo
;    print,b_xhi

    widget_control,(*pState).xlo_nb,get_value = nb_xlo
  ;   help,nb_xlo
   ;  print,nb_xlo
 ;  prevent first bin point being set to a value less than the lowest non-bin point
         if float(b_xlo[0]) lt float(nb_xlo[0]) then $
    widget_control,event.id,set_value=nb_xlo
  ; prevent first bin point being set to a value greater than the maximum value of x
        if float(b_xlo[0]) gt max((*pState).x) then $
    widget_control,event.id,set_value=max((*pState).x)
    widget_control,event.id,get_value=b_xlo
;   There are two ways of accessing widget information,and sadly I use both
;   Set the last non-bin point ot hte value of the first binned-point
    last_non_bin_point_id=widget_info(event.top, $
    find_by_uname='last_non_bin_point')
;    print,'val =',val
    widget_control,last_non_bin_point_id,set_value=b_xlo
;   now change bin entries
    widget_control,(*pState).xlo_nb,get_value = nb_xlo
    widget_control,(*pState).xhi_nb,get_value = nb_xhi
     x=(*pState).x
     nb_xlo=float(nb_xlo[0])
     nb_xhi=float(nb_xhi[0])
     ;print,nb_xlo
     ;print,nb_xhi
     ;help,nb_xlo
     ;help,nb_xhi
 ;    help,x
 ;    help,nb_xhi
 ;    print,max(x) lt nb_xhi
     upper_cond=where(x lt nb_xhi)
 ;    for i = 0,n_elements(x)-1 do begin
 ;    print, i
 ;    print, x[i] lt nb_xhi
 ;    print,''
 ;    endfor
  ;   print,x[589]
 ;    print,nb_xhi
 ;    print,n_elements(upper_cond)
 ;    help,upper_cond
  ;     print,''
   ;print,nb_xhi
  ;   help,nb_xhi
     xtemp=x[where(x ge nb_xlo) and upper_cond]
;     print,where(x lt nb_xhi)
 ;   help,xtemp
    nb_nbins=n_elements(xtemp)
 ;   help,nb_nbins
    if upper_cond[0] eq -1 then nb_nbins[0] = 0
     ;widget_control,(*pState).ndesired_b,get_value = b_nbins
    ; b_nbins=fix(b_nbins[0])
    ;     if (nb_nbins+b_nbins) gt (*pState).total_bins then $
     b_nbins=(*pState).total_bins-fix(nb_nbins[0])
     widget_control,(*pState).ndesired_nb,set_value = nb_nbins
     widget_control,(*pState).ndesired_b,set_value = b_nbins
;   Calculate step size
    widget_control,(*pState).xhi_b,get_value = b_xhi
    if (fix(b_nbins[0])-1) le 0 then begin
    step=0.0
    i_nbins=0
    i_xlo=float(b_xlo[0])
    i_xhi=float(b_xlo[0])
    b_xhi=float(b_xlo[0])
    widget_control,(*pState).ndesired_i,set_value = i_nbins
    widget_control,(*pState).xlo_i,set_value = i_xlo
    widget_control,(*pState).xhi_i,set_value = i_xhi
    widget_control,(*pState).xhi_b,set_value = b_xhi
    ;    print,step
    endif else begin
    step=(float(b_xhi[0])-float(b_xlo[0]))/(fix(b_nbins[0])-1)
    endelse
     widget_control,(*pState).step_size,set_value = step

    ;   find interpolated range
    x=(*pState).x
;    print,(fix(nb_nbins[0])+1)
;    print,(fix(nb_nbins[0])+1)+fix(b_nbins[0])
;   This next bit is diffiuclt to avoid bugs
    where_x_lt_b_xhi=where(x lt float(b_xhi[0])-step/100.0,count)
;    print,(fix(nb_nbins[0])+1)
;    print,n_elements(where_x_le_b_xhi)
;    print,'woof',float(b_xhi[0])
;   Since the last index is count and not count-1, we are including the last entry
    ix=x[fix(nb_nbins[0])-1:count]
  ;  help,ix
    ;ix=x[(fix(nb_nbins[0])+1):*]
    ix_plus=ix[1:*]
    ix_minus=ix[0:(n_elements(ix)-1)]
    ix_diff=ix_plus-ix_minus
    ;print,ix_diff
    u=1+bytarr(n_elements(ix_diff))
    ustep=step*u
    where_int=where(ix_diff gt ustep,count)
    ;print,'where_int =',where_int
    ;print,'where_int + 1 =',where_int+1
    if count ge 1 then begin
;   help,ix
    ix=[ix[0],ix[(where_int+1)]]
;   help,ix
    i_nbins=count+1
    i_xlo=b_xlo
    i_xhi=max(ix)
    endif else begin
    i_nbins=0
    i_xlo=b_xlo
    i_xhi=b_xlo
    endelse
    widget_control,(*pState).ndesired_i,set_value = i_nbins
    widget_control,(*pState).xlo_i,set_value = i_xlo
    widget_control,(*pState).xhi_i,set_value = i_xhi


    end

'b_bins':    $
    begin
  ;  print,'(*pState).total_bins =',(*pState).total_bins
    nb_bin_id=widget_info(event.top,  $
    find_by_uname='nb_bins')
    widget_control,nb_bin_id,get_value=nb_nbins
    widget_control,event.id,get_value=b_nbins
  ;  prevent sum of bins in the two areas exceeding the total number of bins
      if (fix(nb_nbins[0])+fix(b_nbins[0])) gt (*pState).total_bins then begin
    widget_control,event.id,set_value=(*pState).total_bins-nb_nbins
    endif
    ;   Calculate step size
    widget_control,(*pState).xlo_b,get_value = b_xlo
    widget_control,(*pState).xhi_b,get_value = b_xhi
    widget_control,(*pState).ndesired_b,get_value = b_nbins
    if (fix(b_nbins[0])-1) le 0 then begin
    step=0.0
    i_nbins=0
    i_xlo=float(b_xlo[0])
    i_xhi=float(b_xlo[0])
    b_xhi=float(b_xlo[0])
    widget_control,(*pState).ndesired_i,set_value = i_nbins
    widget_control,(*pState).xlo_i,set_value = i_xlo
    widget_control,(*pState).xhi_i,set_value = i_xhi
    widget_control,(*pState).xhi_b,set_value = b_xhi
    endif else begin
    step=(float(b_xhi[0])-float(b_xlo[0]))/(fix(b_nbins[0])-1)
    endelse
     widget_control,(*pState).step_size,set_value = step

        ;   find interpolated range
    x=(*pState).x

    where_x_lt_b_xhi=where(x lt float(b_xhi[0])-step/100.0,count)
  ;  print, 'woof'
  ;  print,(fix(nb_nbins[0])+1)
  ;  print,n_elements(where_x_le_b_xhi)
  ;  print,'woof'
    ix=x[fix(nb_nbins[0])-1:count]
    ;ix=x[(fix(nb_nbins[0])+1):*]
    ix_plus=ix[1:*]
    ix_minus=ix[0:(n_elements(ix)-1)]
    ix_diff=ix_plus-ix_minus
    ;print,ix_diff
    u=1+bytarr(n_elements(ix_diff))
    ustep=step*u
    where_int=where(ix_diff gt ustep,count)
    ;print,'where_int =',where_int
    ;print,'where_int + 1 =',where_int+1
    if count ge 1 then begin
;   help,ix
    ix=[ix[0],ix[(where_int+1)]]
;   help,ix
    i_nbins=count+1
    i_xlo=b_xlo
    i_xhi=max(ix)
    endif else begin
    i_nbins=0
    i_xlo=b_xlo
    i_xhi=b_xlo
    endelse
    widget_control,(*pState).ndesired_i,set_value = i_nbins
    widget_control,(*pState).xlo_i,set_value = i_xlo
    widget_control,(*pState).xhi_i,set_value = i_xhi


  end
'last_bin_point':    $
begin
    widget_control,event.id,get_value=b_xhi
 ;  prevent last bin point being set to a value greater than max(x)
    if float(b_xhi[0]) gt max((*pState).x) then begin
    b_xhi=max((*pState).x)
    widget_control,event.id,set_value=b_xhi
    endif
    ;   Calculate step size
    widget_control,(*pState).ndesired_b,get_value = b_nbins
    widget_control,(*pState).xlo_b,get_value = b_xlo
    if float(b_xhi[0]) le float(b_xlo[0]) then begin
    x=(*pState).x
    where_gt=where(x gt float(b_xlo[0]))
    b_xhi=x[where_gt[0]]
        widget_control,event.id,set_value=b_xhi
    endif
        if (fix(b_nbins[0])-1) le 0 then begin
    step=0.0
    i_nbins=0
    i_xlo=float(b_xlo[0])
    i_xhi=float(b_xlo[0])
    b_xhi=float(b_xlo[0])
    widget_control,(*pState).ndesired_i,set_value = i_nbins
    widget_control,(*pState).xlo_i,set_value = i_xlo
    widget_control,(*pState).xhi_i,set_value = i_xhi
    widget_control,(*pState).xhi_b,set_value = b_xhi
    endif else begin
    step=(float(b_xhi[0])-float(b_xlo[0]))/(fix(b_nbins[0])-1)
    endelse
     widget_control,(*pState).step_size,set_value = step
     widget_control,(*pState).xhi_b,get_value =b_xhi


    widget_control,(*pState).ndesired_nb,get_value = nb_nbins
        ;   find interpolated range
    x=(*pState).x

    where_x_lt_b_xhi=where(x lt float(b_xhi[0])-step/100.0,count)
;    print, fix(nb_nbins[0])
;    print,count
;    print, 'float(b_xhi[0]) =',float(b_xhi[0])
;    print,'max(x)',max(x)
 ;   print,'x[fix(nb_nbins[0])-1] =',x[fix(nb_nbins[0])-1]
 ;   print,'x[count] =',x[count]
 ;    print,n_elements(x)
;help,x
 ;   print,'x[count] =',x[count]

;    print,(fix(nb_nbins[0])+1)
 ;   print,n_elements(x)
;    print,'float(b_xhi[0]) =',float(b_xhi[0])
;    print,'woof'

    ix=x[fix(nb_nbins[0])-1:count]
  ;  help,ix
  ;  print,ix
  ;  ix=x[(fix(nb_nbins[0])+1):*]
  ;  help,ix
  ;  print,ix
    ix_plus=ix[1:*]
    ix_minus=ix[0:(n_elements(ix)-1)]
    ix_diff=ix_plus-ix_minus
    ;print,ix_diff
    u=1+bytarr(n_elements(ix_diff))
    ustep=step*u
    where_int=where(ix_diff gt ustep,count)
    ;print,'where_int =',where_int
    ;print,'where_int + 1 =',where_int+1
    if count ge 1 then begin
;   help,ix
    ix=[ix[0],ix[(where_int+1)]]
;   help,ix
    i_nbins=count+1
    i_xlo=b_xlo
    i_xhi=max(ix)
    endif else begin
    i_nbins=0
    i_xlo=b_xlo
    i_xhi=b_xlo
    endelse
    widget_control,(*pState).ndesired_i,set_value = i_nbins
    widget_control,(*pState).xlo_i,set_value = i_xlo
    widget_control,(*pState).xhi_i,set_value = i_xhi


end

'Range_Types':    $
begin
        widget_control,(*pState).Accept_Range,get_value = Range_Types
 ;   Range_Types_id=widget_info(event.top,  $
 ;   find_by_uname='Range_Types')
 ;   widget_control,Range_Types_id,get_value=Range_Types
 ;   help,Range_Types
  ;  print,Range_Types
(*pState).out.Range=Range_Types
end
else:
endcase

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro unit_change_Energy,event,unit_arr=unit_arr
widget_control,event.top,get_uvalue = pState

; convert from meV to wavenumbers
if unit_arr[0] eq 0 and unit_arr[1] eq 1 then conv=8.06554097
; convert from meV to GHz
if unit_arr[0] eq 0 and unit_arr[1] eq 2 then conv=241.7989052
; convert from wavenumbers to meV
if unit_arr[0] eq 1 and unit_arr[1] eq 0 then conv=0.123984244
; convert from wavenumbers to GHz
if unit_arr[0] eq 1 and unit_arr[1] eq 2 then conv=29.97925447
; convert from GHz to meV
if unit_arr[0] eq 2 and unit_arr[1] eq 0 then conv=4.135668022e-3
; convert from GHz to wavenumbers
if unit_arr[0] eq 2 and unit_arr[1] eq 1 then conv=0.03335639987
;
     widget_control,(*pState).xlo_nb,get_value = nb_xlo
nb_xlo=double(nb_xlo[0])*conv
     widget_control,(*pState).xlo_nb,set_value = nb_xlo
;
     widget_control,(*pState).xhi_nb,get_value = nb_xhi
nb_xhi=double(nb_xhi[0])*conv
     widget_control,(*pState).xhi_nb,set_value = nb_xhi
;
     widget_control,(*pState).xlo_b,get_value = b_xlo
b_xlo=double(b_xlo[0])*conv
     widget_control,(*pState).xlo_b,set_value = b_xlo
;
     widget_control,(*pState).xhi_b,get_value = b_xhi
b_xhi=double(b_xhi[0])*conv
     widget_control,(*pState).xhi_b,set_value = b_xhi
;
     widget_control,(*pState).xlo_i,get_value = i_xlo
i_xlo=double(i_xlo[0])*conv
     widget_control,(*pState).xlo_i,set_value = i_xlo
;
     widget_control,(*pState).xhi_i,get_value = i_xhi
i_xhi=double(i_xhi[0])*conv
     widget_control,(*pState).xhi_i,set_value = i_xhi
;
     widget_control,(*pState).step_size,get_value = step_size
step_size=double(step_size[0])*conv
     widget_control,(*pState).step_size,set_value = step_size
;
    (*pState).x*=conv
;print,unit_arr
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function opan_rebin_focus_Energy_widget, x,nb_xlo=nb_xlo,nb_xhi=nb_xhi,nb_nbins=nb_nbins, $
                    b_xlo=b_xlo,b_xhi=b_xhi,b_nbins=b_nbins,step=step, $
                    i_xlo=i_xlo,i_xhi=i_xhi,i_nbins=i_nbins, $
                    range=range,unit=unit,group_leader = group_leader
;
nb_nbins=fix(nb_nbins)
b_nbins=fix(b_nbins)
i_nbins=fix(i_nbins)
range=fix(range)
unit=fix(unit)
;
;
if n_elements(group_leader) eq 0 then begin
  tlb = widget_base(/col,title = 'Energy Rebinning Utility',/tlb_frame_attr,/align_center)
endif else begin
  tlb = widget_base(group_leader = group_leader, /col,/modal, $
        title = 'Energy Rebinning Utility',/tlb_frame_attr,/align_center)
endelse
base = widget_base(tlb,/row)
total_bins=n_elements(x)
;print,'total_bins =',total_bins
;if min(x) lt -50.0 then begin
;nb_xlo=-50.0
;xtemp=x(where(x ge min(x)) and where(x lt -50.0))
;total_bins-=n_elements(xtemp)
;x=x[n_elements(xtemp):*]
;print,n_elements(x)
;endif else begin
;nb_xlo=min(x)
;endelse
basel = widget_base(base,/col)
baser = widget_base(base,/col)
base1 = widget_base(basel,/col,/frame)
void = widget_label(base1,value = 'Range Without Binning')
ndesired_nb = cw_field(base1,/row,uname='nb_bins',value = string(nb_nbins),title = '# of channels',/noedit)
xlo_nb = cw_field(base1,/row,value = string(nb_xlo),title = 'Lower limit',/noedit)
xhi_nb = cw_field(base1,/row,uname='last_non_bin_point',value =string(nb_xhi),title = 'Upper limit',/noedit)

base2 = widget_base(basel,/col,/frame)
void = widget_label(base2,value = 'Range With Binning')
ndesired_b = cw_field(base2,/row,uname='b_bins',value = string(b_nbins),title = '# of channels',/return_events)
xlo_b = cw_field(base2,/row,uname='first_bin_point',value = string(b_xlo),title = 'Lower limit',/return_events)
xhi_b = cw_field(base2,/row,uname='last_bin_point',value = string(b_xhi),title = 'Upper limit',/return_events)
step_size = cw_field(base2,/row,uname='step_size',value = string(step),title = 'Step Size',/return_events)

base3 = widget_base(baser,/col,/frame)
void = widget_label(base3,value = 'Binned Range With Interpolation')
ndesired_i = cw_field(base3,/row,uname='i_bins',value = string(i_nbins),title = '# of channels',/noedit)
xlo_i = cw_field(base3,/row,uname='first_i_point',value = string(i_xlo),title = 'Lower limit',/noedit)
xhi_i = cw_field(base3,/row,uname='last_i_point',value = string(i_xhi),title = 'Upper limit',/noedit)

base4 = widget_base(baser,/col,/frame)





Accept_Range_Types = ['All',$
              'Binned', $
              'Binned Without Interpolation']
;range=1
Accept_Range = cw_bgroup(base4,Accept_Range_Types,/col,/exclusive,label_top='Range to Include',$
           set_value = range,/return_index, /frame,$
           uname = 'Range_Types')



Unit_Types = ['meV',$
              'cm-1', $
              'GHz']
;unit=0
Units = cw_bgroup(base4,Unit_Types,/row,/exclusive,label_top='Units',$
           set_value = Unit,/return_index, /frame,$
           uname = 'Units')



;base5 = widget_base(basel,/row,/base_align_right)

acceptButton = widget_button(base2,value = 'Accept')
cancelButton = widget_button(base2,value = 'Cancel')
;woofButton = widget_button(base5,/align_center,value = 'woof')

widget_control,tlb,/realize

out = {nb_xlo:nb_xlo,nb_xhi:nb_xhi,nb_nbins:nb_nbins,b_xlo:b_xlo,b_xhi:b_xhi,b_nbins:b_nbins, $
       i_xlo:i_xlo,i_xhi:i_xhi,i_nbins:i_nbins,step:step,  $
       range:range, unit:unit, cancel:1}
state = {out:out, $
        x:x,   $
         ndesired_nb:ndesired_nb, xlo_nb:xlo_nb, xhi_nb:xhi_nb, $
         ndesired_b:ndesired_b, xlo_b:xlo_b, xhi_b:xhi_b, step_size:step_size, $
         ndesired_i:ndesired_i, xlo_i:xlo_i, xhi_i:xhi_i, Accept_Range:Accept_Range,   $
         units:units, total_bins:total_bins,  $
         cancelButton:cancelButton, $
         acceptButton:acceptButton}

pState = ptr_new(state,/no_copy)
widget_control,tlb,set_uvalue = pState
xmanager,'opan_rebin_focus_Energy_widget',tlb,event_handler = 'opan_focus_Energy_rw'

out = (*pState).out
ptr_free,pState
;print,'out =',out
return,out
end