; $Id: fdavehfbsreducerawdata.pro,v 1.3 2005/02/09 16:58:00 dimeo Exp $
;###############################################################################
;
; NAME:
;  FDAVEHFBSREDUCERAWDATA
;
; PURPOSE:
;  Application launcher for HFBS data reduction.
;
; CATEGORY:
;  DAVE, HFBS, Data Reduction
;
; AUTHOR:
;   Robert M. Dimeo, Ph.D.
;   NIST Center for Neutron Research
;   100 Bureau Drive
;   Gaithersburg, MD 20899
;   Phone: (301) 975-8135
;   E-mail: robert.dimeo@nist.gov
;   http://www.ncnr.nist.gov/staff/dimeo
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveHFBSReduceRawData,event
widget_control,event.top,get_uvalue = pState,/no_copy
thisEvent = tag_names(event,/structure_name)
case thisEvent of

'WIDGET_BUTTON':$
  begin
      widget_control,event.top,set_uvalue = pState,/no_copy
      daveDeSensitizeButtons,event
      widget_control,event.top,get_uvalue = pState,/no_copy
      inPtr = ptr_new(*pState)
      hfbs_davereduce,[event.id,event.top],inPtr,group_leader = event.top
  end

'HFBSREDUCEEVENT': $
  begin
  *pState = *event.inPtr
  ptr_free,event.inPtr
  widget_control,event.top,set_uvalue = pState,/no_copy
  daveSensitizeButtons,event
  widget_control,event.top,get_uvalue = pState,/no_copy
  end
else:
endcase
widget_control,event.top,set_uvalue = pState,/no_copy
return
end