; $Id: hfbs_displaytreatment.pro,v 1.3 2005/02/09 16:58:01 dimeo Exp $
;###############################################################################
;
; NAME:
;  HFBS_DISPLAYTREATMENT
;
; PURPOSE:
;  Widget that displays the treatment of the data.
;
; CATEGORY:
;  DAVE, HFBS, utility
;
; AUTHOR:
;   Robert M. Dimeo, Ph.D.
;   NIST Center for Neutron Research
;   100 Bureau Drive
;   Gaithersburg, MD 20899
;   Phone: (301) 975-8135
;   E-mail: robert.dimeo@nist.gov
;   http://www.ncnr.nist.gov/staff/dimeo
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
;;;;;;;;;;;;
pro HFBS_DisplayTreatment,event
; Display file header info and the contents of the treatment
widget_control,event.top,get_uvalue = pState,/no_copy
if n_elements(*(*(*(*pState).inPtr).dataStrPtr).commonStr.treatmentPtr) eq 0 then begin
  text = 'No data has been loaded'
  void = dialog_message(dialog_parent = event.top,text)
  widget_control,event.top,set_uvalue = pState,/no_copy
  return
endif
text = [*(*(*(*pState).inPtr).dataStrPtr).commonStr.treatmentPtr]
void = HFBS_DispTreat(group_leader = event.top,text)
widget_control,event.top,set_uvalue = pState,/no_copy
return
end