; $Id: hfbs_disptreat.pro,v 1.3 2005/02/09 16:58:01 dimeo Exp $
;###############################################################################
;
; NAME:
;  HFBS_DISPTREAT
;
; PURPOSE:
;  Displays data treatment
;
; CATEGORY:
;  DAVE, HFBS, utility
;
; AUTHOR:
;   Robert M. Dimeo, Ph.D.
;   NIST Center for Neutron Research
;   100 Bureau Drive
;   Gaithersburg, MD 20899
;   Phone: (301) 975-8135
;   E-mail: robert.dimeo@nist.gov
;   http://www.ncnr.nist.gov/staff/dimeo
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
;;;;;;;;;;;;
pro dispTreatQuit,event
widget_control,event.top,/destroy
return
end
;;;;;;;;;;;;
pro HFBS_DispTreat_event,event
return
end
;;;;;;;;;;;;
function HFBS_DispTreat,group_leader = group_leader,treatment
; Display file header info and the contents of the treatment
tlb = widget_base(group_leader = group_leader,$
                           title = 'Data Treatment and Comments',$
                           /modal,/col)
void = widget_text(tlb,value = treatment,xsize = 50,ysize = 20,/scroll)
quit = widget_button(tlb,value = 'Dismiss',event_pro = 'dispTreatQuit')
centertlb,tlb
widget_control,tlb,/realize
xmanager,'HFBS_DispTreat',tlb
return,0
end