; $Id: hfbs_selsym.pro,v 1.5 2005/02/09 16:58:01 dimeo Exp $
;###############################################################################
;
; NAME:
;  HFBS_SELSYM
;
; PURPOSE:
;  Plot symbol selection function.
;
; CATEGORY:
;  DAVE, HFBS, utility
;
; AUTHOR:
;   Robert M. Dimeo, Ph.D.
;   NIST Center for Neutron Research
;   100 Bureau Drive
;   Gaithersburg, MD 20899
;   Phone: (301) 975-8135
;   E-mail: robert.dimeo@nist.gov
;   http://www.ncnr.nist.gov/staff/dimeo
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function hfbs_selsym,index
mindex = index mod 11
case mindex of
 0: begin
    numsym = hfbs_plotsym(/circle,scale = 0.75,/fill)
    end
 1: begin
    numsym = hfbs_plotsym(/triangle,scale = 0.75)
    end
 2: begin
    numsym = hfbs_plotsym(/diamond,scale = 0.75)
    end
 3: begin
    numsym = hfbs_plotsym(/box,scale = 0.75)
    end
 4: begin
    numsym = hfbs_plotsym(/line,scale = 0.75)
    end
 5: begin
    numsym = 0		; continuous line
    end
 6: begin
    numsym = -hfbs_plotsym(/circle,scale = 0.75,/fill)
    end
 7: begin
    numsym = -hfbs_plotsym(/triangle,scale = 0.75)
    end
 8: begin
    numsym = -hfbs_plotsym(/diamond,scale = 0.75)
    end
 9: begin
    numsym = -hfbs_plotsym(/box,scale = 0.75)
    end
 10: begin
     numsym = -hfbs_plotsym(/line,scale = 0.75)
     end
endcase
return,numsym
end