; $Id: davedat2d__print.pro,v 1.3 2005/02/08 17:17:34 azuah Exp $
;###############################################################################
;
; CLASS NAME:
;   DaveDat2D
;
; PURPOSE:
;   This class encapsulates a DAVE formated dataset containing 2D
;   data.
;
; CATEGORY:
;   Data Browser
;
; SUPERCLASSES:
;   DaveDat
;
; PUBLIC METHODS:
;   Clone
;   Get
;   Print
;   Rebin
;   ResetData
;   Restore
;   Set
;   Transpose
;   XSpec
;
; AUTHOR:
;   Richard Tumanjong Azuah
;   NIST Center for Neutron Research
;   100 Bureau Drive, Gaithersburg, MD 20899
;   United States
;   azuah@nist.gov; (301) 9755604
;   Oct, 2002
;
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;###############################################################################



;===============================================================================
; DaveDat2D::print
;
; PURPOSE:
;   Private utility method which can be used during development to
;   print a summary of a DaveDat2D object.
;
; PARAMETERS:
;
; KEYWORDS:
;
pro DaveDat2D::print

print,'_________________________________________________________________________'
print,'### DaveDat2D object: brief info'
print,''
fstr1 = '(A,T30,A)'
fstr2 = '(A,T30,G10.4)'
fstr3 = '(A,T30,I5)' 
if ptr_valid(self.yvPtr) then print,format=fstr3,'Yaxis -- length: ',n_elements(*self.yvPtr)
print,format=fstr1,'Yaxis -- label: ',self.ylabel
print,format=fstr1,'Yaxis -- type: ',self.ytype
print,format=fstr1,'Yaxis -- units: ',self.yunits
print,''
print,'The inherited component of DaveDat2D follows...'
self->DaveDat::print

end
