; $Id: davegr__print.pro,v 1.4 2005/02/08 17:17:34 azuah Exp $
;###############################################################################
;
; CLASS NAME:
;   DaveGr
;
; PURPOSE:
;   This DaveGr class defines an entity which consists of one or more
;   datasets and all the necessary properties or attributes to display
;   or plot the dataset(s). A dataset is contained in a DaveDat
;   object and can be manipulated using that class' methods.
;
; CATEGORY:
;   Data Browser
;
; SUPERCLASSES:
;   IDL_CONTAINER
;
; PUBLIC METHODS:
;   Add
;   Get
;   Remove
;   Set
;
; AUTHOR:
;   Richard Tumanjong Azuah
;   NIST Center for Neutron Research
;   100 Bureau Drive, Gaithersburg, MD 20899
;   United States
;   azuah@nist.gov; (301) 9755604
;   Oct, 2002
;
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;###############################################################################



;===============================================================================
; DaveGr::print
;
; PURPOSE:
;   Private utility method which can be used during development to
;   print a summary of a DaveGr object.
;
; PARAMETERS:
;
;
pro DaveGr::print

print,'______________________________'
print,'### DaveGr object: brief info'
print,''
print,'********** Label, inUse'
print,'label.text: ',self.label.text
print,'label.position: ',self.label.position
print,'label.color: ',self.label.color
print,''
print,'Nos of datasets: ',self->count()
print,''
if (self->count() ge 1) then begin
    print,'********** dataObj ==> composition'
    dr = self->get(/all)
    for i=0,self->count()-1 do begin
        ;void = self->get(dataRef=dr,position=i)
        void = (dr[i])->get(nameTag=name)
        print,name
    endfor
endif

end

