; $Id: launch_dave_db.pro,v 1.3 2005/01/24 17:34:51 azuah Exp $
;###############################################################################
;
; NAME:
;   launch_dave_db
;
; PURPOSE:
;   Launch procedure for the 'Data Browser' module in DAVE.
;
; CATEGORY:
;   Data Browser
;
; AUTHOR:
;   Richard Tumanjong Azuah
;   NIST Center for Neutron Research
;   100 Bureau Drive, Gaithersburg, MD 20899
;   United States
;   azuah@nist.gov; (301) 9755604
;   April, 2003
;
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################



;===============================================================================
; launch_dave_db
;
; PURPOSE:
;   Launch procedure for the 'Data Browser' module in DAVE.
;
; PARAMETERS:
;   event [in] - the event generated when the Data Browser menu is
;                selected from DAVE
;
pro launch_dave_db,event

widget_control,event.top,get_uvalue = pState

db_interface,	GROUP_LEADER = event.top,WORKING_DIRECTORY = (*!dave_defaults).workDir, $
                data=(*pState).davePtr

end
