; $Id: create_drop_menu_items.pro,v 1.2 2005/02/09 13:38:36 dimeo Exp $
;###############################################################################
;
; NAME:
;  CREATE_DROP_MENU_ITEMS
;
; PURPOSE:
;  Menu utility for widgets
;
; CATEGORY:
;  DAVE, ASCII data reader, widgets
;
; AUTHOR:
;   Robert M. Dimeo, Ph.D.
;   NIST Center for Neutron Research
;   100 Bureau Drive
;   Gaithersburg, MD 20899
;   Phone: (301) 975-8135
;   E-mail: robert.dimeo@nist.gov
;   http://www.ncnr.nist.gov/staff/dimeo
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function create_drop_menu_items,drop_menu,list
if n_elements(list) eq 0 then return,0
for i = 0,n_elements(list)-1 do $
   void = widget_button(drop_menu,value = list[i],uname = $
      strupcase(list[i]),/checked_menu)
ret = set_menu_check_item(drop_menu,sel = 0)
return,1
end