;###############################################################################
;
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
;
pro cdm

; Build a widget hierarchy that contains a dialog.
t=widget_base()
d=dialog_pickfile(dialog_parent=t,/directory)
widget_control,t,/realize

; Change directories, based on user input.
cd,current=c
if (d ne "" and d ne " " and strupcase(d) ne strupcase(c+"\")) then begin
	cd, d
	message, "Changing directory to ''"+d+"''",$
		/noname,/info
endif else begin
	message, "Directory remains ''"+c+"''",$
		/noname,/info
endelse

; Destroy the widget hierarchy.
	widget_control,t,/destroy

end
