;$Id: dave_dialog_pickfile.pro,v 1.4 2005/02/03 18:04:12 azuah Exp $
;###############################################################################
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
;
; DAVE_Dialog_Pickfile is a wrapper for dialog_pickfile.
; It changes the current directory to the one
;  that the picked file is located
;  and sets !dave_defaults accordingly.
;
function dave_dialog_pickfile $
	, read = read $
	, write = write $
	, _extra = _extra

	defsysv, '!dave_defaults', exists=exists
	if exists then exists = exists * ptr_valid( !dave_defaults )

	cd, current = current

	if exists then begin

		if keyword_set( write ) then begin

			if current ne (*!dave_defaults).workDir then $
				cd, (*!dave_defaults).workDir

		endif else begin

			if current ne (*!dave_defaults).datDir then $
				cd, (*!dave_defaults).datDir

		endelse

	endif

	; Pick the files.
	files = dialog_pickfile( read = read, write = write, _extra = _extra )
	file = files[0]
	if file eq '' then return, file

	; Call davesysvars to make sure !windows & !delimiters are present.
	davesysvars
	match = '.*' + !delimiter
	if !windows then match = match + !delimiter
	;
	dir = stregex( file, match, /extract ) ; Select only the directory part.
	message, 'Chaning directory to ' + dir, /continue
	cd, dir

	if exists then begin

		if keyword_set( read ) then begin

			(*!dave_defaults).datDir = dir

		endif

		if keyword_set( write ) then begin

			(*!dave_defaults).workDir = dir

		endif

	endif

	dir = stregex( file, match, /extract )
	message, 'Changing directory to ' + dir, /continue
	cd, dir

	return, files

end
