; $Id: launch_vmhelp.pro,v 1.3 2005/02/03 18:04:12 azuah Exp $
;###############################################################################
;
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
;************************************************************************************************
function launch_vmhelp,pdf_file,tlb = tlb
;************************************************************************************************
;
compile_opt strictarr
;
;
if (n_params() ne 1) then return,0
;
PDFReader=''
file=sourceroot()+"pdfreader.txt"
if (file_test(file)) then begin
	openr,unit,file,/get_lun
	readf,unit,PDFReader
	free_lun,unit
endif
;
if (PDFReader eq '' or PDFReader eq ' ') then begin
	if (n_elements(tlb) gt 0) then begin
		res=dialog_message("You must first define your pdf reader",/error,dialog_parent=tlb)
	endif else begin
		res=dialog_message("You must first define your pdf reader",/error)
	endelse
	return,2
endif
;
;
run_command = PDFReader + " " + pdf_file
;
if (strlowcase(!version.os_family) eq "windows") then begin
	spawn, run_command,/noshell,/nowait
	return,0
endif
if (strlowcase(!version.os_family) eq "unix") then begin
	spawn, run_command+" &"
	return,0
endif
if (strlowcase(!version.os_family) eq "macos") then begin
	spawn, run_command,/nowait
	return,0
endif
;
return,-1
end
