; $Id: dave_set_focus.pro,v 1.2 2005/02/09 13:53:50 dimeo Exp $
;###############################################################################
;
; NAME:
;  DAVE_SET_FOCUS
;
; PURPOSE:
;  Utility for grabbing currently selected plot window.
;
; CATEGORY:
;  DAVE, electronic notebook.
;
; AUTHOR:
;   Robert M. Dimeo, Ph.D.
;   NIST Center for Neutron Research
;   100 Bureau Drive
;   Gaithersburg, MD 20899
;   Phone: (301) 975-8135
;   E-mail: robert.dimeo@nist.gov
;   http://www.ncnr.nist.gov/staff/dimeo
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
function dave_set_focus,item,_Extra = extra
ret = 0
item_type = size(item,/tname)
if item_type eq 'LONG' then begin
   tlb = item
   widget_control,tlb,kbrd_focus_events = 1
   ret = dave_find_all_draw_widgets(tlb,_Extra = extra)
   ret = 1
endif
if item_type eq 'STRUCT' then begin
   event = item
   if (tag_names(event,/structure_name) eq 'WIDGET_KBRD_FOCUS') then begin
      if event.enter eq 1 then begin
         ret = dave_find_all_draw_widgets(event.top,_Extra = extra)
      endif
      ret = 1
   endif
endif
return,ret
end