; getpaths.pro
;
; This routine sets the path for executing the programs
; in DAVE.  The root directory is the only one that is
; platform dependent since all directories under it are
; fixed by design.
;
;###############################################################################
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;###############################################################################
;
cd,current=daveDir
delimiter = ':'
; The rest of the statements are platform independent
!path = !path +delimiter+expand_path("+"+daveDir)
;
; get the current date and save it in auxiliary/builddate.txt
; 
cmd = 'date +"%b %d %Y %T" > auxiliary/builddate.txt'
spawn, cmd, /sh
print, 'current date registered in auxiliary/builddate.txt'
cmd = 'cvs ci -m "" auxiliary/builddate.txt'
spawn, cmd, /sh

