;$Id: array_equal_dimension.pro,v 1.3 2005/02/09 14:02:26 azuah Exp $
;###############################################################################
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
function array_equal_dimension $
	, ptr1, ptr2 $
	, histo = histo

	size1 = size( *ptr1 )
	size2 = size( *ptr2 )

	if size1[0] ne size2[0] then return, 0
	if size1[0] eq 0 then return, 1

	if keyword_set( histo ) then begin

		diff = size1[0:size1[0]] - size2[0:size2[0]]
		n_diff = n_elements( diff )

		return, $
			( total( abs( 2 * diff - 1 ) eq ( intarr( n_diff ) + 1 ) ) $
				eq n_diff )

	endif else begin

		return $
			, total( size1[0:size1[0]] eq size2[0:size2[0]] ) $
				eq size1[0] + 1

	endelse

end