;$Id: array_size_equal.pro,v 1.2 2005/02/09 14:02:26 azuah Exp $
; Compares the sizes of the two arrays.
; If everything is identical except values, return 1.
; 0 otherwise.
;
;###############################################################################
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
function array_equal_size $
	, a, b

	if n_elements( a ) eq 0 or n_elements( b ) eq 0 then return, 0

	a_size = size( a )
	b_size = size( b )

	if a_size[0] ne b_size[0] then return, 0

	return, array_equal( a_size[0:a_size[0]], b_size[0:b_size[0]] )

end