;$Id: idl_state_save.pro,v 1.3 2005/02/09 14:02:26 azuah Exp $
;
; IDL_state_save
;
;###############################################################################
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
pro idl_state_restore, pState

	if n_elements( pState ) ne 1 then begin
		message, 'Argument pState is missing.', /continue
		return
	endif

	tvlct $
		, (pstate).color_table.r $
		, (pstate).color_table.g $
		, (pstate).color_table.b
	; ptr_free, color_table

	!p = (pstate).bang_p
	!x = (pstate).bang_x
	!y = (pstate).bang_y
	!z = (pstate).bang_z

	; set_plot, (pstate).device_name

	; ptr_free, pState

end

function idl_state_save

	; device, get_visual_depth = visual_depth

	tvlct, r, g, b, /get
	color_table = { r:r, g:g, b:b }

	return, $
		{ color_table:color_table $
		; , visual_depth:visual_depth $
		; , device_name:!d.name $
		, bang_p:!p $
		, bang_x:!x $
		, bang_y:!y $
		, bang_z:!z $
		}


end