; $Id: launch_dtas.pro,v 1.7 2005/02/09 18:13:38 dimeo Exp $
;###############################################################################
;
; NAME:
;  LAUNCH_DTAS
;
; PURPOSE:
;  Application launcher for the TAS reduction application.
;
; CATEGORY:
;  DAVE, TAS, Data Reduction
;
; AUTHOR:
;   Robert M. Dimeo, Ph.D.
;   NIST Center for Neutron Research
;   100 Bureau Drive
;   Gaithersburg, MD 20899
;   Phone: (301) 975-8135
;   E-mail: robert.dimeo@nist.gov
;   http://www.ncnr.nist.gov/staff/dimeo
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro launch_dtas,event
;widget_control,event.top,get_uvalue = pState
thisEvent = tag_names(event,/structure_name)
print,thisevent
case thisEvent of
'WIDGET_BUTTON': $
   begin
      device,decomposed = 0
      work_dir = (*!dave_defaults).workDir
      data_dir = (*!dave_defaults).datDir
;      strout = 'Launching TAS Data Reduction'
;      void = dialog_message(dialog_parent = event.top,strout,/information)
      ogui = obj_new('dtas_reduction_gui',work_dir = work_dir,data_dir = data_dir, $
         notify_ids = [event.id,event.top],group_leader = event.top)
;        strout = 'GUI Object valid: '+strtrim(string(fix(obj_valid(ogui))),2)
;      void = dialog_message(dialog_parent = event.top,strout,/information)
  end
'WIDGET_TREE_SEL': $
   begin
      device,decomposed = 0
      work_dir = (*!dave_defaults).workDir
      data_dir = (*!dave_defaults).datDir
;      strout = 'Launching TAS Data Reduction'
;      void = dialog_message(dialog_parent = event.top,strout,/information)
      ogui = obj_new('dtas_reduction_gui',work_dir = work_dir,data_dir = data_dir, $
         notify_ids = [event.id,event.top],group_leader = event.top)
;        strout = 'GUI Object valid: '+strtrim(string(fix(obj_valid(ogui))),2)
;      void = dialog_message(dialog_parent = event.top,strout,/information)
  end
'DTAS_EVENT': $
  begin
   widget_control,event.top,/show,/input_focus,iconify = 0
  end
else:
endcase
end