;$Id: oQueue__define.pro,v 1.3 2005/02/09 14:02:26 azuah Exp $
;###############################################################################
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro test

	o = obj_new('oQueue', max = 2048)

	o -> push, 'abcd'
	o -> push, 'bcde'
	o -> push, 'fghi'
	o -> get, n = n
	print, n

	p = o -> shift()
	print, p
	o -> get, n = n
	print, n

	p = o -> shift()
	print, p
	o -> get, n = n
	print, n

	p = o -> shift()
	print, p
	o -> get, n = n
	print, n

	p = o -> shift()
	print, p
	o -> get, n = n
	print, n

	obj_destroy, o

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
function oQueue::full

	if self.N eq 0 then return, 0
	return, 1

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro oQueue::get, max=max, n=n

	max = self.max
	n = self.N

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro oQueue::set, max=max, open = open, null = null

	if n_elements( max ) eq 1 then self.max = long( max )
	self.open = keyword_set( open )

	if n_elements( null ) eq 0 then null = 0
	self.null = ptr_new( null, /no_copy )

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro oQueue::push, content

	case self.N of
		0: begin

			ptrNew = ptr_new( $
				{ prev:ptr_new(/allocate_heap) $
				, next:ptr_new(/allocate_heap) $
				, content:ptr_new( content ) $
				}, /no_copy )

			self.first = ptrNew
			self.last = ptrNew

		end
		self.max: begin

			if self.open then begin

				p = self -> shift()
				self -> push, content

			endif else begin

				message, $
					'Cannot push the content into the queue anymore.', /continue

			endelse

		end
		else: begin

			ptrNew = ptr_new( $
				{ prev:self.last $
				, next:ptr_new(/allocate_heap) $
				, content:ptr_new( content ) $
				}, /no_copy )

			(*self.last).next = ptrNew
			self.last = ptrNew

		end
	endcase

	self.N = self.N + 1

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
function oQueue::shift

	if self.N eq 0 then return, *self.null
	self.N = self.N - 1

	first = self.first
	second = (*self.first).next
	self.first = second
	if ptr_valid( (*first).content ) then begin
		content = *(*first).content
		ptr_free, (*first).content
		return, content
	endif

	return, *self.null

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
function oQueue::init, _extra = _extra

	self.N = 0
	self -> set, _extra = _extra
	return, 1

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro oQueue::cleanup

	heap_free, self.null

	if self.N eq 0 then return

	while self.N gt 0 do begin

		o = self -> shift()
		if ptr_valid( o[0] ) then pointer_recursive_free, o[0]

	endwhile

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro oQueue__define

	void = { oQueue $
		;
		, N:0L $
		, max:1024L $
		, open:0B $
		, null:ptr_new() $

		, first:ptr_new() $
		, last:ptr_new() $
		}

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************