;$Id: oram__define.pro,v 1.3 2005/02/09 14:02:26 azuah Exp $
;###############################################################################
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro test

	o = obj_new('oRAM', max = 2048, null = '')

	print, '1', o -> load(1, 'abcd')
	print, '2', o -> load(2, 'efgh')
	print, '3', o -> load(1)

	obj_destroy, o
    heap_gc, /verbose

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;
; void = oRAM -> load( 7, 'apple')
; print, oRAM -> load( 7 )
;
function oRAM::load, n, content

	case n_params() of
		0: return, *self.null
		1: begin
			if n ge self.max then return, *self.null
			if n_elements( *((*self.ptrMem)[n]) ) eq 0 then return, *self.null
			return, *((*self.ptrMem)[n])
		end
		2: begin
			if n ge self.max then return, *self.null
			prev_ptr = (*self.ptrMem)[n]
			if n_elements( *prev_ptr ) eq 0 then begin
				prev_content = *self.null
			endif else begin
				prev_content = *prev_ptr
			endelse
			*((*self.ptrMem)[n]) = content
			return, prev_content
		end
	endcase

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
function oRAM::init, max = max, null = null

	if n_elements( max ) eq 0 then max = 1024
	self.max = max

	if n_elements( null ) eq 0 then null = 0
	self.null = ptr_new( null )

	self.ptrMem = ptr_new( ptrarr( self.max, /allocate_heap ) )

	return, 1

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro oRAM::cleanup

	pointer_recursive_cleanup, self.null
	pointer_recursive_cleanup, self.ptrMem

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro oRAM__define

	void = { oRAM $
		;
		, max:1024L $
		, null:ptr_new() $
		;
		, ptrMem:ptr_new() $
		;
		}

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************