; $Id: tasid.pro,v 1.3 2003/10/28 19:54:41 jmspark Exp $
;
; TASID
;
;  SYNOPSYS
;
;     TasID is a useful utility to find the index for the given label.
;     For example, when a different x-axis is desired, the index
;     for the new axis from the data structure can be found using
;     tasID.
;
;  INPUT
;     txt = axis label, e.g., 'H', 'K', 'L', 'E', etc.
;     d = the data structure of the tasrd type.
;
;  RETURNS
;     the index for the given axis label from d.prp string array
;     or -1 if no match is found.
;
;  EXAMPLE
;
;     d = tasrd( file )
;     index = tasID( 'H', d )
;     x = d.data[ index, * ]
;
function tasid,txt,d
   tnum=where(d.prp eq strupcase(txt))
   if tnum(0) eq -1 then tnum=where(d.prp eq txt)
   return,tnum(0)
end












